package org.vono.narau.cupcake.exercise;

import org.vono.narau.cupcake.Common;
import org.vono.narau.cupcake.R;
import org.vono.narau.cupcake.kanji.KanjiArrayAdapter;
import org.vono.narau.cupcake.kanji.KanjiDB;
import org.vono.narau.cupcake.kanji.KanjiData;

import android.app.ListActivity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ListView;

public class DrillMenuActivity extends ListActivity implements OnItemClickListener {
	// private static final String TAG =
	// DrillMenuActivity.class.getSimpleName();
	public static final String DRILL_DIRECTION = "dir";
	public static final String DRILL_DIRECTION_TO = "to";
	public static final String DRILL_DIRECTION_FROM = "from";

	private String direction;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		direction = super.getIntent().getExtras().getString(DRILL_DIRECTION);

		// Setup this activity title
		// since it it shared between 2 different activities
		if (DRILL_DIRECTION_FROM.equals(direction)) {
			super.setTitle(R.string.drillFromJap);
		} else {
			super.setTitle(R.string.drillToJap);
		}

		final boolean dbAvail = Common.haveAllDBAvail(Common.DB_MASK_KANJI);
		int disabledTypeMask = 0;
		if (!dbAvail) {
			disabledTypeMask = KanjiData.KANJI;
		}

		ListView listView = super.getListView();

		KanjiArrayAdapter kaa = new KanjiArrayAdapter(this.getApplicationContext(),
				DrillCharActivity.TYPE_MASK, disabledTypeMask);

		listView.setAdapter(kaa);
		listView.setOnItemClickListener(this);
	}

	public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
		Object tag = view.getTag();

		if (tag instanceof KanjiData.WritingCategory) {
			KanjiData.WritingCategory wc = (KanjiData.WritingCategory) tag;

			Intent intent = new Intent(this.getApplicationContext(), DrillCharActivity.class);

			intent.putExtra(KanjiArrayAdapter.ITEM_CATEGORY, wc);
			intent.putExtra(DrillMenuActivity.DRILL_DIRECTION, this.direction);
			super.startActivity(intent);

		}
	}

	public static boolean haveDatabase() {
		return KanjiDB.isReady();
	}
}
